diff --git a/src/BRepClass/BRepClass_FaceExplorer.cxx b/src/BRepClass/BRepClass_FaceExplorer.cxx
index 3fb9b5b..c55c653 100644
--- a/src/BRepClass/BRepClass_FaceExplorer.cxx
+++ b/src/BRepClass/BRepClass_FaceExplorer.cxx
@@ -1,4 +1,4 @@
-// Created on: 1992-11-19
+﻿// Created on: 1992-11-19
 // Created by: Remi LEQUETTE
 // Copyright (c) 1992-1999 Matra Datavision
 // Copyright (c) 1999-2014 OPEN CASCADE SAS
@@ -18,48 +18,224 @@
 //  Total rewriting of the method Segment; add the method OtherSegment.
 
 #include <BRep_Tool.hxx>
-#include <BRepClass_Edge.hxx>
 #include <BRepClass_FaceExplorer.hxx>
 #include <BRepTools.hxx>
+#include <BRepTools_WireExplorer.hxx>
 #include <Geom2d_Curve.hxx>
 #include <gp_Lin2d.hxx>
 #include <gp_Pnt2d.hxx>
 #include <Precision.hxx>
+#include <TopExp.hxx>
 #include <TopoDS.hxx>
 #include <TopoDS_Face.hxx>
-
-static const Standard_Real Probing_Start = 0.123;
-static const Standard_Real Probing_End = 0.7;
-static const Standard_Real Probing_Step = 0.2111;
+#include <TopoDS_Wire.hxx>
+#include <NCollection_Vector.hxx>
+#include <TopTools_MapOfShape.hxx>
+#include <NCollection_IncAllocator.hxx>
+#include <Geom2dAdaptor_Curve.hxx>
+#include <TopoDS_Vertex.hxx>
+#include <Geom2d_Line.hxx>
+#include <ElCLib.hxx>
+#include <Adaptor3d_CurveOnSurface.hxx>
+#include <Geom2dAdaptor_HCurve.hxx>
+#include <GeomAdaptor_HSurface.hxx>
+#include <TopClass_RayInfo.hxx>
+#include <Geom2dAdaptor_Curve.hxx>
+#include <TopClass_GeomVertex.hxx>
+
+static Standard_Real SquareDistanceOnPeriodic(const gp_Pnt2d &theP1,
+                                              const gp_Pnt2d &theP2,
+                                              const Standard_Real theUPeriod,
+                                              const Standard_Real theVPeriod);
+
+static Standard_Boolean MyUVPoints(const TopoDS_Edge& theE,
+                                   const TopoDS_Face& theF,
+                                   gp_Pnt2d& thePFirst,
+                                   gp_Pnt2d& thePLast);
+
+
+const Standard_Real BRepClass_FaceExplorer::myProbing_Start = 0.123;
+const Standard_Real BRepClass_FaceExplorer::myProbing_End = 0.7;
+const Standard_Real BRepClass_FaceExplorer::myProbing_Step = 0.2111;
 
 //=======================================================================
 //function : BRepClass_FaceExplorer
 //purpose  : 
 //=======================================================================
+BRepClass_FaceExplorer::BRepClass_FaceExplorer(const TopoDS_Face& theF)
+  : myBoundsComputed(Standard_False),
+    myUMin(0.), myUMax(0.), myVMin(0.), myVMax(0.),
+    myCurEdgeInd(0), myCurEdgePar(0.)
+
+{
+  Init(theF);
+}
 
-BRepClass_FaceExplorer::BRepClass_FaceExplorer(const TopoDS_Face& F) :
-       myFace(F),
-       myCurEdgeInd(1),
-       myCurEdgePar(Probing_Start)
+//=======================================================================
+//function : Init
+//purpose  : BRepTools_WireExplorer works better with
+//            and more reliable with FORWARD-oriented face.
+//=======================================================================
+void BRepClass_FaceExplorer::Init(const TopoDS_Face& theF)
 {
-  myFace.Orientation(TopAbs_FORWARD);
+  if (myFace.IsSame(theF))
+  {
+    //The classifier has already been initialized.
+    return;
+  }
+
+  myMapWE.Clear();
+
+  myFace = TopoDS::Face(theF.Oriented(TopAbs_FORWARD));
+  Handle(NCollection_IncAllocator) anAlloc = new NCollection_IncAllocator;
+  mySurf = BRep_Tool::Surface(myFace);
+  GeomAdaptor_Surface anAdS(mySurf);
+
+  const Standard_Real aUPeriod = anAdS.IsUPeriodic() ? anAdS.UPeriod() : 0.0;
+  const Standard_Real aVPeriod = anAdS.IsVPeriodic() ? anAdS.VPeriod() : 0.0;
+
+  for (TopoDS_Iterator anExpW(myFace); anExpW.More(); anExpW.Next())
+  {
+    if (anExpW.Value().ShapeType() == TopAbs_WIRE)
+    {
+      const TopoDS_Wire &aWir = TopoDS::Wire(anExpW.Value());
+      NCollection_List<TopClass_GeomEdge> anEList(anAlloc);
+      myMapWE.Add(aWir, anEList);
+    }
+  }
+
+  if (myMapWE.IsEmpty())
+    return;
+
+  TopTools_IndexedDataMapOfShapeListOfShape aMapVE;
+  TopExp::MapShapesAndUniqueAncestors(myFace, TopAbs_VERTEX, TopAbs_EDGE, aMapVE);
+
+  InitWires();
+
+  for (; myWExplorer.More(); myWExplorer.Next())
+  {
+    const TopoDS_Wire &aWir = TopoDS::Wire(myWExplorer.Key());
+    NCollection_List<TopClass_GeomEdge>& anEList = myWExplorer.ChangeValue();
+    anEList.Clear();
+
+    BRepTools_WireExplorer anExp(aWir, myFace);
+
+    TopoDS_Edge anE1 = anExp.Current(), aFirstEdge, aLastEdge;
+
+    if (anE1.IsNull())
+    {
+      // It is possible if aWir contains
+      // only INTERNAL/EXTERNAL edges.
+
+      continue;
+    }
+
+    aFirstEdge = anE1;
+    SimpleAdd(anE1);
+    anExp.Next();
+
+    if (!anExp.More())
+    {
+      // The wire contains only single edge.
+      // But this edge can be closed itself (e.g. circle).
+
+      TopoDS_Vertex aVf, aVl;
+      TopExp::Vertices(anE1, aVf, aVl);
+      if (!aVf.IsNull() && aVf.IsSame(aVl))
+        AddPseudo(anE1, anE1, aVf.IsNull() ? aVl : aVf, aUPeriod, aVPeriod);
+
+      continue;
+    }
+
+    for (; anExp.More(); anExp.Next())
+    {
+      const TopoDS_Edge& anE2 = anExp.Current();
+      aLastEdge = anE2;
+      SimpleAdd(anE2);
+
+      const TopoDS_Vertex &aVertCurr = anExp.CurrentVertex();
+      AddPseudo(anE1, anE2, aVertCurr, aUPeriod, aVPeriod);
+      anE1 = anE2;
+    }
+
+    if (aFirstEdge.IsNull() || aLastEdge.IsNull())
+      continue;
+
+    //TopExp::CommonVertex(...) does not work
+    //if edges have more than one pair of common vertex
+    //(e.g. two halves of circle). Here, we process this case.
+    TopoDS_Vertex aV[4];
+    TopExp::Vertices(aFirstEdge, aV[0], aV[1]);
+    if (!aV[0].IsNull() && aV[0].IsSame(aV[1]))
+    {
+      // Possible reason is the NOT-CLOSED edge
+      // has only single vertex and is covered by it.
+      // Pseudo-edge is not added and this case is invalid.
+      continue;
+    }
+
+    TopExp::Vertices(aLastEdge, aV[2], aV[3]);
+    if (!aV[2].IsNull() && aV[2].IsSame(aV[3]))
+    {
+      // Possible reason is the NOT-CLOSED edge
+      // has only single vertex and is covered by it.
+      // Pseudo-edge is not added and this case is invalid.
+      continue;
+    }
+
+    for (Standard_Integer anIDFE = 0; anIDFE < 2; anIDFE++)
+    {
+      for (Standard_Integer anIDLE = 2; anIDLE < 4; anIDLE++)
+      {
+        if (!aV[anIDFE].IsSame(aV[anIDLE]))
+          continue;
+
+        const NCollection_List<TopoDS_Shape> *anEList = aMapVE.Seek(aV[anIDFE]);
+        if ((anEList != 0) && (anEList->Extent() > 2))
+        {
+          // Causes:
+          //  1. Non-manifold topology.
+          //  2. Case such as:
+          //
+          //        *************************
+          //        *                       *
+          //  seam  *                       *  seam
+          //        *  edge1         edge2  *
+          //        * ********    ********* *
+          //       V1        V2   V3       V4
+          //
+          //
+          //  V1 - vertex between edge1 and seam
+          //  V4 - vertex between edge2 and seam
+          //
+          //  Indeed, V1 and V4 are same but they
+          //  must not be joined.
+
+          continue;
+        }
+
+
+        AddPseudo(aFirstEdge, aLastEdge, aV[anIDFE], aUPeriod, aVPeriod);
+      }
+    }
+  }
+
+  //InitWires();
+  //InitEdges();
 }
 
 //=======================================================================
 //function : CheckPoint
 //purpose  : 
 //=======================================================================
-
 Standard_Boolean  BRepClass_FaceExplorer::CheckPoint(gp_Pnt2d& thePoint)
 {
   Standard_Real anUMin = 0.0, anUMax = 0.0, aVMin = 0.0, aVMax = 0.0;
-  TopLoc_Location aLocation;
-  const Handle(Geom_Surface)& aSurface = BRep_Tool::Surface(myFace, aLocation);
-  aSurface->Bounds(anUMin, anUMax, aVMin, aVMax);
+  mySurf->Bounds(anUMin, anUMax, aVMin, aVMax);
   if (Precision::IsInfinite(anUMin) || Precision::IsInfinite(anUMax) ||
       Precision::IsInfinite(aVMin) || Precision::IsInfinite(aVMax))
   {
-    BRepTools::UVBounds(myFace, anUMin, anUMax, aVMin, aVMax);
+    UVBounds(anUMin, anUMax, aVMin, aVMax);
     if (Precision::IsInfinite(anUMin) || Precision::IsInfinite(anUMax) ||
         Precision::IsInfinite(aVMin) || Precision::IsInfinite(aVMax))
     {
@@ -91,192 +267,470 @@ Standard_Boolean  BRepClass_FaceExplorer::CheckPoint(gp_Pnt2d& thePoint)
 }
 
 //=======================================================================
-//function : Reject
+//function : ListOfRays
 //purpose  : 
 //=======================================================================
-
-Standard_Boolean  BRepClass_FaceExplorer::Reject(const gp_Pnt2d&)const 
+Standard_Boolean BRepClass_FaceExplorer::OtherRay(const gp_Pnt2d& theP,
+                                                  TopClass_RayInfo& theRay,
+                                                  const unsigned int theMaxRating)
 {
+#define NextSegmentMacro {myCurEdgeInd++; myCurEdgePar = myProbing_Start; continue;}
+
+  const Standard_Real aTolParConf2 = Precision::SquarePConfusion();
+  Standard_Real       aFPar, aLPar;
+
+  gp_Dir2d aLinDir;
+  Standard_Integer i = 1;
+  for(TopoDS_Iterator aWExp(myFace); aWExp.More(); aWExp.Next())
+  {
+    // aWire is wire
+    const TopoDS_Shape &aWire = aWExp.Value();
+    for(TopoDS_Iterator anEExp(aWire); anEExp.More(); anEExp.Next(), i++)
+    {
+      if(i > myCurEdgeInd)
+        return Standard_False;
+
+      if(i != myCurEdgeInd)
+        continue;
+
+      if(myCurEdgePar >= myProbing_End)
+      {
+        NextSegmentMacro;
+      }
+
+      const TopoDS_Edge &anEdge = TopoDS::Edge(anEExp.Value());
+      const TopAbs_Orientation anOrientation = anEdge.Orientation();
+
+      if((anOrientation != TopAbs_FORWARD) &&
+         (anOrientation != TopAbs_REVERSED))
+      {
+        NextSegmentMacro;
+      }
+
+      const Handle(Geom2d_Curve) aC2d = BRep_Tool::CurveOnSurface(anEdge,
+                                                                  myFace,
+                                                                  aFPar,
+                                                                  aLPar);
+
+      if(aC2d.IsNull())
+      {
+        NextSegmentMacro;
+      }
+
+      // Treatment of infinite cases.
+      if(Precision::IsNegativeInfinite(aFPar))
+      {
+        if(Precision::IsPositiveInfinite(aLPar))
+        {
+          aFPar = -1.;
+          aLPar = 1.;
+        }
+        else
+        {
+          aFPar = aLPar - 1.;
+        }
+      }
+      else if(Precision::IsPositiveInfinite(aLPar))
+      {
+        aLPar = aFPar + 1.;
+      }
+
+      for(; myCurEdgePar < myProbing_End; myCurEdgePar += myProbing_Step)
+      {
+        TopClass_RayInfo aRI;
+        aLinDir.SetCoord(1.0, 0.0);
+
+        const Standard_Real aParamIn = myCurEdgePar*aFPar + (1. - myCurEdgePar)*aLPar;
+
+        gp_Pnt2d aPOnC;
+        gp_Vec2d aTanVec;
+        aC2d->D1(aParamIn, aPOnC, aTanVec);
+
+        const Standard_Real aPrmTemp = aPOnC.SquareDistance(theP);
+        if(aPrmTemp > aTolParConf2)
+        {
+          aLinDir.SetXY(aPOnC.XY() - theP.XY());
+          Standard_Real aTanMod = aTanVec.SquareMagnitude();
+          if(aTanMod < aTolParConf2)
+          {
+            aRI.AddPenalty(10);
+          }
+          else
+          {
+            const Standard_Real aSinA = Abs(aTanVec.Crossed(aLinDir.XY())) / Sqrt(aTanMod);
+            // The line from the input point P to the current point on edge
+            // is tangent to the edge curve. This condition is bad for classification.
+            // Therefore, we add penalty for this ray.
+
+            if(aSinA < 0.001)
+            {
+              aRI.AddPenalty(3);
+            }
+            else if(aSinA < 0.02)
+            {
+              aRI.AddPenalty(2);
+            }
+            else if(aSinA < 0.1)
+            {
+              aRI.AddPenalty(1);
+            }
+          }
+        }
+        else
+        {
+          aRI.AddPenalty(10);
+        }
+
+        if(aRI.GetWeight() < theMaxRating)
+        {
+          aRI.SetLin(gp_Lin2d(theP, aLinDir));
+          aRI.SetParameter(Sqrt(aPrmTemp));
+
+          theRay = aRI;
+          myCurEdgePar += myProbing_Step;
+          return Standard_True;
+        }
+      }// for (; myCurEdgePar < ...
+
+      NextSegmentMacro;
+    }//for(TopoDS_Iterator anEExp(aWire) ...
+  } //for(TopoDS_Iterator aWExp(myFace) ...
+
   return Standard_False;
+
+#undef NextSegmentMacro
 }
 
 //=======================================================================
-//function : Segment
+//function : InitWires
 //purpose  : 
 //=======================================================================
 
-Standard_Boolean BRepClass_FaceExplorer::Segment(const gp_Pnt2d& P, 
-						 gp_Lin2d& L,
-						 Standard_Real& Par)
+void  BRepClass_FaceExplorer::InitWires()
 {
-  myCurEdgeInd = 1;
-  myCurEdgePar = Probing_Start;
-
-  return OtherSegment(P, L, Par);
+  myWExplorer = NCollection_IndexedDataMap<TopoDS_Wire,
+                      NCollection_List<TopClass_GeomEdge>>::Iterator(myMapWE);
 }
 
 //=======================================================================
-//function : OtherSegment
+//function : SimpleAdd
 //purpose  : 
 //=======================================================================
+void BRepClass_FaceExplorer::SimpleAdd(const TopoDS_Edge &theEdge)
+{
+#ifdef BREPCLASS_FACEEXPLORER_DEBUG
+  {
+    std::cout << "BRepClass_FaceExplorer::SimpleAdd(...) DEBUG " << std::endl;
+    std::cout << "Edge orientation (0F, 1R, 2I, 3E) == " << 
+                                          theEdge.Orientation() << std::endl;
+
+    gp_Pnt2d aPF, aPL;
+    MyUVPoints(theEdge, myFace, aPF, aPL);
 
-Standard_Boolean BRepClass_FaceExplorer::OtherSegment(const gp_Pnt2d& P, 
-						      gp_Lin2d& L,
-						      Standard_Real& Par)
+    std::cout << "PF(" <<aPF.X() << ", " << aPF.Y() << ")" << std::endl;
+    std::cout << "PL(" <<aPL.X() << ", " << aPL.Y() << ")" << std::endl;
+  }
+#endif
+
+  Standard_Real aFPar, aLPar;
+  const Handle(Geom2d_Curve) aC2d = BRep_Tool::CurveOnSurface(theEdge, myFace, aFPar, aLPar);
+  const TopClass_GeomEdge aGE(theEdge, mySurf, aC2d, aFPar, aLPar);
+
+  if (aGE.IsNull())
+    return;
+
+  NCollection_List<TopClass_GeomEdge>& anEList = myWExplorer.ChangeValue();
+  anEList.Append(aGE);
+}
+
+//=======================================================================
+//function : AddPseudo
+//purpose  : 
+//=======================================================================
+void BRepClass_FaceExplorer::AddPseudo(const TopoDS_Edge& theE1,
+                                       const TopoDS_Edge& theE2,
+                                       const TopoDS_Vertex& theV,
+                                       const Standard_Real theUPeriod,
+                                       const Standard_Real theVPeriod)
 {
-  TopExp_Explorer      anExpF(myFace,TopAbs_EDGE);
-  Standard_Integer     i;
-  Standard_Real        aFPar;
-  Standard_Real        aLPar;
-  Handle(Geom2d_Curve) aC2d;
-  Standard_Real        aTolParConf2 = Precision::PConfusion() * Precision::PConfusion();
-  gp_Pnt2d             aPOnC;
-  Standard_Real        aParamIn;
-
-  for (i = 1; anExpF.More(); anExpF.Next(), i++) {
-    if (i != myCurEdgeInd)
-      continue;
+  gp_Pnt2d aPFirst, aPLast;
+  TopAbs_Orientation anOriFirst = theE1.Orientation(), anOriLast = theE2.Orientation();
 
-    const TopoDS_Shape       &aLocalShape   = anExpF.Current();
-    const TopAbs_Orientation  anOrientation = aLocalShape.Orientation();
-
-    if (anOrientation == TopAbs_FORWARD || anOrientation == TopAbs_REVERSED) {
-      const TopoDS_Edge &anEdge = TopoDS::Edge(aLocalShape);
-
-      aC2d = BRep_Tool::CurveOnSurface(anEdge, myFace, aFPar, aLPar);
-
-      if (!aC2d.IsNull()) {
-	// Treatment of infinite cases.
-	if (Precision::IsNegativeInfinite(aFPar)) {
-	  if (Precision::IsPositiveInfinite(aLPar)) {
-	    aFPar = -1.;
-	    aLPar =  1.;
-	  } else {
-	    aFPar = aLPar - 1.;
-	  }
-	} else if (Precision::IsPositiveInfinite(aLPar))
-	  aLPar = aFPar + 1.;
-
-	for (; myCurEdgePar < Probing_End ;myCurEdgePar += Probing_Step) {
-	  aParamIn = myCurEdgePar*aFPar + (1. - myCurEdgePar)*aLPar;
-
-          gp_Vec2d aTanVec;
-	  aC2d->D1(aParamIn, aPOnC, aTanVec);
-	  Par = aPOnC.SquareDistance(P);
-
-	  if (Par > aTolParConf2) {
-	    gp_Vec2d aLinVec(P, aPOnC);
-	    gp_Dir2d aLinDir(aLinVec);
-
-            Standard_Real aTanMod = aTanVec.SquareMagnitude();
-            if (aTanMod < aTolParConf2)
-              continue;
-            aTanVec /= Sqrt(aTanMod);
-            Standard_Real aSinA = aTanVec.Crossed(aLinDir.XY());
-            const Standard_Real SmallAngle = 0.001;
-            if (Abs(aSinA) < SmallAngle)
-            {
-              // The line from the input point P to the current point on edge
-              // is tangent to the edge curve. This condition is bad for classification.
-              // Therefore try to go to another point in the hope that there will be 
-              // no tangent. If there tangent is preserved then leave the last point in 
-              // order to get this edge chanse to participate in classification.
-              if (myCurEdgePar + Probing_Step < Probing_End)
-                continue;
-            }
+  if ((anOriFirst != TopAbs_FORWARD) && (anOriFirst != TopAbs_REVERSED))
+    return;
 
-	    L = gp_Lin2d(P, aLinDir);
+  if ((anOriLast != TopAbs_FORWARD) && (anOriLast != TopAbs_REVERSED))
+    return;
 
-	    // Check if ends of a curve lie on a line.
-	    aC2d->D0(aFPar, aPOnC);
+  Standard_Boolean isSame = Standard_False;
 
-	    if (L.SquareDistance(aPOnC) > aTolParConf2) {
-	      aC2d->D0(aLPar, aPOnC);
+  if (theE1.IsEqual(theE2))
+  {
+    // source Wire contains single edge only
+    // with single vertex but the edge can be
+    // geometrically not-closed (e.g. the part
+    // of some circle).
+    // BRep_Tool::UVPoints(...) returns equal points for this case. It is inappropriate.
+
+    // The algorithm below will create a pseudo-edge
+    // from aPFirst to aPLast.
+    // But in this case it must join end-point of curve
+    // with its start-point (exactly in this direction).
+    if (!MyUVPoints(TopoDS::Edge(theE1.Oriented(TopAbs_FORWARD)),
+                    myFace, aPLast, aPFirst))
+      return;
+  }
+  else
+  {
+    if (theE1.IsSame(theE2))
+    {
+      //Gap between two seam-edges (e.g. cylinder without bottom-base).
+      //P-curve is (no 2D-curve is bottom)
+      //
+      //          ****************
+      //          *              *
+      //    seam  *              * seam
+      //          *              *
+      //          *              *
+
+      isSame = Standard_True;
+    }
 
-	      if (L.SquareDistance(aPOnC) > aTolParConf2) {
-		myCurEdgePar += Probing_Step;
+    if (!PrepareEdge(theE1, theV, aPFirst, anOriFirst))
+    {
+      return;
+    }
 
-		if (myCurEdgePar >= Probing_End) {
-		  myCurEdgeInd++;
-		  myCurEdgePar = Probing_Start;
-		}
+    if ((anOriFirst != TopAbs_FORWARD) && (anOriFirst != TopAbs_REVERSED))
+      return;
 
-		Par = Sqrt(Par);
-		return Standard_True;
-	      }
-	    }
-	  }
-	}
-      } // if (!aC2d.IsNull()) {
-    } // if (anOrientation == TopAbs_FORWARD ...
+    if (!PrepareEdge(theE2, theV, aPLast, anOriLast))
+      return;
+  }
 
-    // This curve is not valid for line construction. Go to another edge.
-    myCurEdgeInd++;
-    myCurEdgePar = Probing_Start;
+  if ((anOriLast != TopAbs_FORWARD) && (anOriLast != TopAbs_REVERSED))
+    return;
+
+  if (!isSame)
+  {
+    if(SquareDistanceOnPeriodic(aPFirst, aPLast,
+                               theUPeriod, theVPeriod) < Precision::SquarePConfusion())
+    {
+      return;
+    }
+  }
+  else if(aPFirst.SquareDistance(aPLast) < Precision::SquarePConfusion())
+  {
+    return;
   }
 
-  // nothing found, return an horizontal line
-  Par = RealLast();
-  L   = gp_Lin2d(P,gp_Dir2d(1,0));
+#ifdef BREPCLASS_FACEEXPLORER_DEBUG
+  {
+    std::cout << "BRepClass_FaceExplorer::AddPseudo(...) DEBUG " << std::endl;
+    std::cout << "Edge orientation (0F, 1R, 2I, 3E) == " << anOriLast << std::endl;
 
-  return Standard_False;
+    std::cout << "PF(" << aPFirst.X() << ", " << aPFirst.Y() << ")" << std::endl;
+    std::cout << "PL(" << aPLast.X() << ", " << aPLast.Y() << ")" << std::endl;
+  }
+#endif
+
+  const gp_XY aMVec = aPLast.XY() - aPFirst.XY();
+  gp_Lin2d aLin(aPFirst, gp_Dir2d(aMVec));
+  const Standard_Real aFPar = 0.0;
+  const Standard_Real aLPar = aMVec.Modulus();
+  const Handle(Geom2d_Curve) aPseudoEdge = new Geom2d_Line(aLin);
+
+  // Null 3D-curve
+  Handle(Geom_Curve) aC3d;
+
+  // Pseudo-edge. Therefore, parameter of the vertex is not important value.
+  TopClass_GeomVertex aV(theV, aFPar);
+
+  TopClass_GeomEdge aGE(aC3d, aPseudoEdge, mySurf,
+                        aFPar, aLPar, anOriLast, aV, aV, Standard_False);
+
+  NCollection_List<TopClass_GeomEdge>& anEList = myWExplorer.ChangeValue();
+  anEList.Append(aGE);
 }
 
 //=======================================================================
-//function : InitWires
+//function : PrepareEdge
 //purpose  : 
 //=======================================================================
-
-void  BRepClass_FaceExplorer::InitWires()
+Standard_Boolean BRepClass_FaceExplorer::PrepareEdge(const TopoDS_Edge& theEdge,
+                                                     const TopoDS_Vertex& theV,
+                                                     gp_Pnt2d& thePnt,
+                                                     TopAbs_Orientation& theOri)
 {
-  myWExplorer.Init(myFace,TopAbs_WIRE);
+  const TopAbs_Orientation anOri = theEdge.Orientation();
+  if ((anOri != TopAbs_FORWARD) && (anOri != TopAbs_REVERSED))
+    return Standard_False;
+
+  TopoDS_Vertex aVFirst, aVLast;
+  TopExp::Vertices(theEdge, aVFirst, aVLast, Standard_True);
+
+  if (!aVFirst.IsNull() && aVFirst.IsSame(theV))
+  {
+    gp_Pnt2d aPtemp;
+    if (anOri == TopAbs_FORWARD)
+    {
+      if (!MyUVPoints(theEdge, myFace, thePnt, aPtemp))
+        return Standard_False;
+    }
+    else //if(anOri == TopAbs_REVERSED)
+    {
+      if (!MyUVPoints(theEdge, myFace, aPtemp, thePnt))
+        return Standard_False;
+    }
+    theOri = TopAbs_FORWARD;// aVFirst.Orientation();
+  }
+  else if (!aVLast.IsNull() && aVLast.IsSame(theV))
+  {
+    gp_Pnt2d aPtemp;
+
+    if (anOri == TopAbs_FORWARD)
+    {
+      if (!MyUVPoints(theEdge, myFace, aPtemp, thePnt))
+        return Standard_False;
+    }
+    else //if(anOri == TopAbs_REVERSED)
+    {
+      if (!MyUVPoints(theEdge, myFace, thePnt, aPtemp))
+        return Standard_False;
+    }
+    theOri = TopAbs_REVERSED;//aVLast.Orientation();
+  }
+  else
+  {
+    return Standard_False;
+  }
+
+  return Standard_True;
 }
 
 //=======================================================================
-//function : RejectWire NYI
+//function : InitEdges
 //purpose  : 
 //=======================================================================
-
-Standard_Boolean  BRepClass_FaceExplorer::RejectWire
-  (const gp_Lin2d& , 
-   const Standard_Real)const 
+void BRepClass_FaceExplorer::InitEdges()
 {
-  return Standard_False;
+  NCollection_List<TopClass_GeomEdge>& anEList = myWExplorer.ChangeValue();
+  myEExplorer.Initialize(anEList);
 }
 
 //=======================================================================
-//function : InitEdges
+//function : CurrentEdge
 //purpose  : 
 //=======================================================================
-
-void  BRepClass_FaceExplorer::InitEdges()
+void BRepClass_FaceExplorer::CurrentEdge(TopClass_GeomEdge& theGE) const
 {
-  myEExplorer.Init(myWExplorer.Current(),TopAbs_EDGE);
+  theGE = myEExplorer.Value();
 }
 
 //=======================================================================
-//function : RejectEdge NYI
+//function : IsPointInVertex
 //purpose  : 
 //=======================================================================
-
-Standard_Boolean  BRepClass_FaceExplorer::RejectEdge
-  (const gp_Lin2d& , 
-   const Standard_Real )const 
+Standard_Boolean BRepClass_FaceExplorer::
+                    IsPointInEdgeVertex(const gp_Pnt2d &thePnt,
+                                        Standard_Real* const theParameter) const
 {
+  const gp_Pnt aPref(mySurf->Value(thePnt.X(), thePnt.Y()));
+  const TopClass_GeomEdge &anEdge = myEExplorer.Value();
+
+  if (anEdge.FirstVertex().IsSame(aPref))
+  {
+    if (theParameter)
+      *theParameter = anEdge.FirstVertex().ParameterOnEdge();
+
+    return Standard_True;
+  }
+
+  if (anEdge.LastVertex().IsSame(aPref))
+  {
+    if (theParameter)
+      *theParameter = anEdge.LastVertex().ParameterOnEdge();
+
+    return Standard_True;
+  }
+
+  if (theParameter)
+    *theParameter = 0.0;
+
   return Standard_False;
 }
 
-
 //=======================================================================
-//function : CurrentEdge
+//function : UVBounds
 //purpose  : 
 //=======================================================================
+void BRepClass_FaceExplorer::UVBounds(Standard_Real& theUMin, Standard_Real& theUMax,
+                                      Standard_Real& theVMin, Standard_Real& theVMax) const
+{
+  if (!myBoundsComputed)
+  {
+    BRepTools::UVBounds(myFace, myUMin, myUMax, myVMin, myVMax);
+    myBoundsComputed = Standard_True;
+  }
+  theUMin = myUMin;
+  theUMax = myUMax;
+  theVMin = myVMin;
+  theVMax = myVMax;
+}
 
-void  BRepClass_FaceExplorer::CurrentEdge(BRepClass_Edge& E, 
-					  TopAbs_Orientation& Or) const 
+//=======================================================================
+//function : SquareDistanceOnPeriodic
+//purpose  : Computes the distance between two 2D-points in case if they
+//            are in different periodic regions or in same region but near
+//            to the different period boundary. I.e. (example on 1D-object
+//            with period T):
+//            1. Square distance between points X and (X+d+k*T)
+//                (k is an integer number) is equal to d^2 
+//                (instead of (d+k*T)^2).
+//            2. Square distance between points X and T-Y 
+//                (0 <= X <= T, 0 <= Y <= T) is equal to (X+Y)^2 instead of
+//                (T-Y-X)^2.
+//=======================================================================
+Standard_Real SquareDistanceOnPeriodic(const gp_Pnt2d &theP1,
+                                       const gp_Pnt2d &theP2,
+                                       const Standard_Real theUPeriod,
+                                       const Standard_Real theVPeriod)
 {
-  E.Edge() = TopoDS::Edge(myEExplorer.Current());
-  E.Face() = myFace;
-  Or = E.Edge().Orientation();
+  const Standard_Real aDeltaXtmp = theUPeriod > 0.0 ?
+                                      fmod(Abs(theP1.X() - theP2.X()), theUPeriod) :
+                                      Abs(theP1.X() - theP2.X());
+
+  const Standard_Real aDeltaYtmp = theVPeriod > 0.0 ?
+                                      fmod(Abs(theP1.Y() - theP2.Y()), theVPeriod) :
+                                      Abs(theP1.Y() - theP2.Y());
+  const Standard_Real aDeltaX = Min(aDeltaXtmp, Abs(aDeltaXtmp - theUPeriod));
+  const Standard_Real aDeltaY = Min(aDeltaYtmp, Abs(aDeltaYtmp - theVPeriod));
+
+  return (aDeltaX*aDeltaX + aDeltaY*aDeltaY);
 }
 
+//=======================================================================
+//function : MyUVPoints
+//purpose  : Does the same as BRep_Tool::UVPoints but returns
+//            first and last points of 2d-curves (not UV-points of edge vertices).
+//=======================================================================
+Standard_Boolean MyUVPoints(const TopoDS_Edge& theE,
+                const TopoDS_Face& theF,
+                gp_Pnt2d& thePFirst,
+                gp_Pnt2d& thePLast)
+{
+  Standard_Real aFirst = 1.0, aLast = -1.0;
+
+  // Direction of aC does not take into account
+  // the orientation of the edge.
+  const Handle(Geom2d_Curve) aC = BRep_Tool::CurveOnSurface(theE,
+                                                            theF,
+                                                            aFirst,
+                                                            aLast);
+  if (aC.IsNull())
+    return Standard_False;
+
+  aC->D0(aFirst, thePFirst);
+  aC->D0(aLast, thePLast);
+  return Standard_True;
+}
